'use strict';

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _proxy_web = require('./proxy_web');

var _proxy_web2 = _interopRequireDefault(_proxy_web);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PORT = 3000;
var app = (0, _express2.default)();

var proxyRoute = function proxyRoute(req, res) {
  try {
    console.log('Proxying', req.query.url);
    (0, _proxy_web2.default)({
      url: req.query.url,
      method: req.method,
      headers: req.headers
    }, {
      proxyUrl: 'http://localhost:' + PORT + '/proxy?url='
    }).then(function (output) {
      res.status(output.statusCode).set(output.headers).send(output.body);
    });
  } catch (e) {
    console.error(e.stack);
  }
};

app.get('/proxy', proxyRoute);
app.post('/proxy', proxyRoute);
app.put('/proxy', proxyRoute);
app.delete('/proxy', proxyRoute);

app.listen(PORT, function () {
  console.log('Listening on ' + PORT);
});