'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _requestPromiseNative = require('request-promise-native');

var _requestPromiseNative2 = _interopRequireDefault(_requestPromiseNative);

var _htmlparser = require('htmlparser2');

var _htmlparser2 = _interopRequireDefault(_htmlparser);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ent = require('ent');

var _ent2 = _interopRequireDefault(_ent);

var _zlib = require('zlib');

var _zlib2 = _interopRequireDefault(_zlib);

var _escapeStringRegexp = require('escape-string-regexp');

var _escapeStringRegexp2 = _interopRequireDefault(_escapeStringRegexp);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NOT_PROXIED_SCHEMES = ['#', 'data:', 'about:'];

var ProxyResource = function () {
  function ProxyResource(req, options) {
    _classCallCheck(this, ProxyResource);

    this.req = req;
    this.proxyURL = options.proxyUrl;

    this.url = req.url;
    this.parsedUrl = _url2.default.parse(this.url);
    this.host = this.parsedUrl.protocol + '//' + this.parsedUrl.host;
  }

  _createClass(ProxyResource, [{
    key: 'load',
    value: function load() {
      var headers;
      return regeneratorRuntime.async(function load$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              headers = this.req.headers;

              headers.host = this.parsedUrl.host;
              headers.referer = this.host + '/';
              delete headers['accept-encoding'];
              return _context.abrupt('return', (0, _requestPromiseNative2.default)({
                method: this.req.method,
                uri: this.url,
                resolveWithFullResponse: true,
                encoding: null,
                gzip: true,
                headers: headers,
                timeout: 2000
              }));

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'proxy',
    value: function proxy() {
      var _this = this;

      return regeneratorRuntime.async(function proxy$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              return _context3.abrupt('return', new Promise(function _callee(resolve, reject) {
                var response, output;
                return regeneratorRuntime.async(function _callee$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        response = void 0;
                        _context2.prev = 1;
                        _context2.next = 4;
                        return regeneratorRuntime.awrap(_this.load());

                      case 4:
                        response = _context2.sent;
                        _context2.next = 13;
                        break;

                      case 7:
                        _context2.prev = 7;
                        _context2.t0 = _context2['catch'](1);

                        if (_context2.t0.error && !_context2.t0.statusCode) {
                          console.error(_context2.t0.error.toString ? _context2.t0.error.toString('utf8') : _context2.t0.error);
                        }

                        output = {
                          statusCode: _context2.t0.statusCode || 500
                        };

                        if (_context2.t0.response) {
                          output = _extends({}, output, {
                            headers: _this.filterResponseHeaders(_context2.t0.response.headers),
                            body: _this.parse(_context2.t0.response)
                          });
                        }

                        return _context2.abrupt('return', resolve(output));

                      case 13:

                        resolve({
                          statusCode: response.statusCode,
                          headers: _this.filterResponseHeaders(response.headers),
                          body: _this.parse(response)
                        });

                      case 14:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, null, _this, [[1, 7]]);
              }));

            case 1:
            case 'end':
              return _context3.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'filterResponseHeaders',
    value: function filterResponseHeaders(headers) {
      return _lodash2.default.omit(headers, 'x-frame-options', 'content-encoding');
    }
  }, {
    key: 'parse',
    value: function parse(response) {
      var contentType = response.headers['content-type'] || '';
      if (contentType.includes('text/html')) {
        return this.parseHTML(response.body.toString());
      } else if (contentType.includes('text/css')) {
        return this.parseCSS(response.body.toString());
      }
      return response.body;
    }
  }, {
    key: 'parseHTML',
    value: function parseHTML(body) {
      var output = '' + body;
      var urls = [];
      var urlAttrs = ['href', 'src'];

      var parser = new _htmlparser2.default.Parser({
        onopentag: function onopentag(name, attrs) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = urlAttrs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var urlAttr = _step.value;

              if (attrs[urlAttr]) {
                urls.push(attrs[urlAttr].trim());
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }
      }, { decodeEntities: false });
      parser.write(body);
      parser.end();

      var matches = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = urlAttrs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var urlAttr = _step2.value;

          matches.push(urlAttr + '="$0"');
          matches.push(urlAttr + '=\'$0\'');
          matches.push(urlAttr + '=$0');
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = urls[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var url = _step3.value;

          var continueLoop = void 0;
          var _iteratorNormalCompletion4 = true;
          var _didIteratorError4 = false;
          var _iteratorError4 = undefined;

          try {
            for (var _iterator4 = NOT_PROXIED_SCHEMES[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              var scheme = _step4.value;

              if (url.indexOf(scheme) === 0) {
                continueLoop = true;
                break;
              }
            }
          } catch (err) {
            _didIteratorError4 = true;
            _iteratorError4 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
              }
            } finally {
              if (_didIteratorError4) {
                throw _iteratorError4;
              }
            }
          }

          if (continueLoop) {
            continue;
          }

          var newUrl = this.resolveURL(_ent2.default.decode(url));

          var _iteratorNormalCompletion5 = true;
          var _didIteratorError5 = false;
          var _iteratorError5 = undefined;

          try {
            for (var _iterator5 = matches[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
              var match = _step5.value;

              var regexp = new RegExp((0, _escapeStringRegexp2.default)(match.replace('$0', url)), 'g');
              output = output.replace(regexp, match.replace('$0', newUrl));
            }
          } catch (err) {
            _didIteratorError5 = true;
            _iteratorError5 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion5 && _iterator5.return) {
                _iterator5.return();
              }
            } finally {
              if (_didIteratorError5) {
                throw _iteratorError5;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }

      var proxyXHR = _fs2.default.readFileSync(__dirname + '/proxy_xhr.js').toString();
      proxyXHR = proxyXHR.replace('$0', this.resolveURL('/'));
      proxyXHR = proxyXHR.replace("'use strict';", '');
      output = '\n    <script>\n    ' + proxyXHR + '\n    </script>\n    ' + output + '\n    ';

      return output;
    }
  }, {
    key: 'parseCSS',
    value: function parseCSS(body) {
      var _this2 = this;

      var output = '' + body;
      output = output.replace(/url\((.*?)\)/ig, function (match, $0) {
        var url = $0.trim().replace(/^"|'/, '');
        url = url.replace(/"|'$/, '');

        if (url.indexOf('data:') === 0) {
          return 'url(' + $0 + ')';
        }

        return 'url(' + _this2.resolveURL(url) + ')';
      });
      return output;
    }
  }, {
    key: 'resolveURL',
    value: function resolveURL(url) {
      var resolved = void 0;
      if (url.indexOf('//') === 0) {
        resolved = '' + this.parsedUrl.protocol + url;
      } else {
        resolved = _url2.default.resolve(this.url, url);
      }
      return '' + this.proxyURL + encodeURIComponent(resolved);
    }
  }]);

  return ProxyResource;
}();

exports.default = ProxyResource;